<?php
// Related addon for Pixelpost 1.5 
// Version 1.3
//
// Written By Piotr "GeoS" Galas - 2006/02/16
// email: geos@pixelpost.org
// WWW: http://geos.wzzone.com/
//
/*================================================================*/

/****************************************/
/*				configuration variables				*/
/****************************************/

$GLOBALS["both_related"] = 1;		// setting it 1 makes enable storing relation for images in both directions
#$GLOBALS["both_related"] = 0;			// setting it 0 makes disable this future

// Same info as non admin addons
$addon_name = "Related pictures (Admin side)";
$addon_description = "This addon gives option of building related pictures list.<br />I.e. you were in zoo and shoot 3 pictures. Thanks to this addon you can \"connect\" each picture with the rest which is already published at your Pixelpost.<br />
Author: <b><a href=\"mailto:geos@pixelpost.org\">Piotr \"GeoS\" Galas</a></b>
";

$addon_version = "1.3";

// Admin page
if( $_GET['view']=='addons' )
{
// Check to see if the related table exists, if not, create it
$query = "SELECT id1 FROM {$pixelpost_db_prefix}related LIMIT 1";
if( !mysql_query( $query ) ) {
  $query = "CREATE TABLE {$pixelpost_db_prefix}related (
	  id1 INT(11) NOT NULL default '0',
	  id2 INT(11) NOT NULL default '0',
  	PRIMARY KEY  (id1,id2)
	);";
  mysql_query( $query ) or die( "rel_pic#1: ".mysql_error() );
	}
}

// The workspace. Where to activate the function inside index.php
$addon_workspace1 = "new_image_form";
$addon_workspace2 = "image_uploaded";
$addon_workspace3 = "image_deleted";
$addon_workspace4 = "image_edit";

// menu where the addon should appear in admin panel. in this case: images menu
$addon_menu = "";

// What would be the title of submenu of this addon: 12cropimage
$addon_admin_submenu = "";

// What is the function
$addon_function_name1 = "do_form_rel";
$addon_function_name2 = "store_rel";
$addon_function_name3 = "del_rel";
$addon_function_name4 = "edit_rel";

// Check to see if the ban table exists, if exist add the admin function
$query = "SELECT id1 FROM {$pixelpost_db_prefix}related LIMIT 1";
if( mysql_query( $query ) ) {
	// add the function
	add_admin_functions($addon_function_name1,$addon_workspace1,$addon_menu,$addon_admin_submenu);
	add_admin_functions($addon_function_name2,$addon_workspace2,$addon_menu,$addon_admin_submenu);
	add_admin_functions($addon_function_name3,$addon_workspace3,$addon_menu,$addon_admin_submenu);
	add_admin_functions($addon_function_name4,$addon_workspace4,$addon_menu,$addon_admin_submenu);
}
//

function do_form_rel()
{
	global $pixelpost_db_prefix;
	// Get the image list
	$query = "SELECT id, headline, image FROM {$pixelpost_db_prefix}pixelpost ORDER BY id";
	$result = mysql_query($query) or die( "rel_pic#2: ".mysql_error() );
	
	$output = "\n<script type='text/javascript' language='javascript' src='../includes/overlib.js'></script><div align='left' style='padding-left:10px;width:150px'>Related images:<select name='rel_pic[]' multiple size='5'>\n";
	
	while ($row = mysql_fetch_row($result))
		$output .= "<option value='".$row[0]."' onmouseover=\"return overlib('&lt;img src=&quot;../thumbnails/thumb_".$row[2]."&quot; /&gt;', CAPTION, '".$row[1]."', WIDTH, '275',BGCOLOR, '#666666', FGCOLOR, '#ffffff', RIGHT, TEXTCOLOR, '#000000');\" onmouseout=\"return nd();\">".$row[0].". ".stripslashes($row[1])."</option>\n";

	$output .= "</select>\n</div>\n";

	echo $output;
}

function store_rel()
{
	global $pixelpost_db_prefix,$theid,$_POST,$addon_version;
	
	if(!empty($_POST["imgid"]))	$theid = $_POST["imgid"];

	$query = "";

	if(count($_POST['rel_pic']) > 0)
	{
		foreach($_POST['rel_pic'] as $k => $v)
		{
			$query = "INSERT INTO {$pixelpost_db_prefix}related VALUES ($theid,$v)";
			mysql_query($query) or die( "rel_pic#3: ".mysql_error().$query );
			if($GLOBALS["both_related"]==1)
			{
				$query = "INSERT INTO {$pixelpost_db_prefix}related VALUES ($v,$theid)";
				mysql_query($query) or die( "rel_pic#4: ".mysql_error().$query );
			}
		}
	}
}

function del_rel()
{
	global $pixelpost_db_prefix,$_GET,$_POST;

	if(!empty($_POST["imgid"]))	$_GET['imageid'] = $_POST["imgid"];

	$query = "DELETE FROM {$pixelpost_db_prefix}related WHERE id1 = '" . $_GET['imageid']."'";
	if($GLOBALS["both_related"]==1) $query .= " OR id2 = '" . $_GET['imageid'] . "'";
	mysql_query($query) or die( "rel_pic#5: ".mysql_error() );
}

function edit_rel()
{
	global $pixelpost_db_prefix,$_GET,$admin_lang_imgedit_u_post_button;

	// Get the image list with relations
	$query = "SELECT a.id, a.headline, a.image, b.id2 FROM {$pixelpost_db_prefix}pixelpost a LEFT JOIN {$pixelpost_db_prefix}related b ON (a.id = b.id2 AND b.id1 = '" . $_GET["id"] . "') WHERE a.id != '" . $_GET["id"] . "' ORDER BY a.id DESC;";
	$result = mysql_query($query) or die( "rel_pic#6: ".mysql_error() );
	
	$output = "\n<script type='text/javascript' language='javascript' src='../includes/overlib.js'></script><form method='post' action='$PHP_SELF?view=images&amp;x=update&amp;imageid=".$_GET["id"]."'><div align='left' style='padding-left:10px;width:150px'>Related images:<select name='rel_pic[]' multiple size='5'>\n";
	
	while ($row = mysql_fetch_row($result))
	{
		$output .= "<option value='".$row[0]."'";
		if(strlen($row[3])>0)	$output .= " selected";
		$output .= " onmouseover=\"return overlib('&lt;img src=&quot;../thumbnails/thumb_".$row[2]."&quot; /&gt;', CAPTION, '".$row[1]."', WIDTH, '275',BGCOLOR, '#666666', FGCOLOR, '#ffffff', RIGHT, TEXTCOLOR, '#000000');\" onmouseout=\"return nd();\">".$row[0].". ".stripslashes($row[1])."</option>\n";
	}
	
	$output .= "</select>\n<br /><input type='hidden' value='" . $_GET["id"] . "' name='imgid' /><input type='submit' value='".$admin_lang_imgedit_u_post_button."' /></div>\n";

	echo $output;
}

if($_GET['view'] == "images" && $_GET['x'] == "update" && $_GET["imageid"] >= 0)
{
	del_rel();
	store_rel();
}

?>